<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryForm" :inline="true" v-show="showSearch" label-width="88px">
      <el-form-item label="小区名称" prop="areaId">
        <el-input v-model="queryParams.areaName" placeholder="请输入小区名称" clearable size="small"
                  @keyup.enter.native="handleQuery"/>
<!--        <el-select v-model="queryParams.areaId" filterable placeholder="请选择所属楼宇"-->
<!--                   clearable size="small" >-->
<!--          <el-option v-for="item in areaList"-->
<!--                     :key="item.id"-->
<!--                     :label="item.name"-->
<!--                     :value="item.id"/>-->
<!--        </el-select>-->
      </el-form-item>
      <el-form-item label="发现问题" prop="findProblem">
        <el-select v-model="queryParams.findProblem" placeholder="请选择发现问题" clearable size="small">
          <el-option
            v-for="dict in dict.type.courtyard_leakage"
            :key="dict.value"
            :label="dict.label"
            :value="dict.value"
          />
        </el-select>
      </el-form-item>
      <el-form-item label="队伍">
        <el-select v-model="queryParams.ranks" clearable placeholder="请选择" @change="getUsers" :disabled="postName.indexOf('xx') > -1&&postName!='xxallrank'">
          <el-option
            v-for="item in postOptions"
            :key="item.postId"
            :label="item.postName"
            :value="item.postId"
          ></el-option>
        </el-select>
      </el-form-item>
      <el-form-item label="上传人" prop="createBy">
        <el-select v-model="queryParams.createBy" filterable placeholder="请选择上传人" clearable size="small">
          <el-option v-for="item in workerListSelect"
                     :key="item.id"
                     :label="item.name"
                     :value="item.id"/>
        </el-select>
      </el-form-item>
      <el-form-item label="审核状态">
        <el-select v-model="queryParams.processStatus" placeholder="请选择审核状态" clearable size="small">
          <el-option
            v-for="dict in dict.type.process_status"
            :key="dict.value"
            :label="dict.label"
            :value="dict.value"
          />
        </el-select>
      </el-form-item>
      <el-form-item label="时间范围" prop="createTimes">
        <el-date-picker
          v-model="queryParams.createTimes"
          type="datetimerange"
          :picker-options="pickerOptions"
          range-separator="至"
          start-placeholder="开始日期"
          end-placeholder="结束日期"
          align="right">
        </el-date-picker>
      </el-form-item>
      <el-form-item>
        <el-button type="primary" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>
        <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <!--      <el-col :span="1.5">-->
      <!--        <el-button-->
      <!--          type="primary"-->
      <!--          plain-->
      <!--          icon="el-icon-plus"-->
      <!--          size="mini"-->
      <!--          @click="handleAdd"-->
      <!--          v-hasPermi="['gas:courtyardNetworkManagement:add']"-->
      <!--        >新增</el-button>-->
      <!--      </el-col>-->
      <!--      <el-col :span="1.5">-->
      <!--        <el-button-->
      <!--          type="success"-->
      <!--          plain-->
      <!--          icon="el-icon-edit"-->
      <!--          size="mini"-->
      <!--          :disabled="single"-->
      <!--          @click="handleUpdate"-->
      <!--          v-hasPermi="['gas:courtyardNetworkManagement:edit']"-->
      <!--        >修改</el-button>-->
      <!--      </el-col>-->
      <el-col :span="1.5">
        <el-button
          type="danger"
          plain
          icon="el-icon-delete"
          size="mini"
          :disabled="multiple"
          @click="handleDelete"
          v-hasPermi="['gas:courtyardNetworkManagement:remove']"
        >删除
        </el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="danger"
          plain
          icon="el-icon-search"
          size="mini"
          :disabled="multiple"
          @click="openshShow(null,true)"
          v-hasPermi="['gas:regulatingBoxMaintenance:remove']"
        >批量审核
        </el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="danger"
          plain
          icon="el-icon-s-claim"
          size="mini"
          :disabled="multiple"
          @click="chushiBatch"
          v-if="['deputyDirector','director','admin'].includes(this.$store.state.user.postName)"
        >一键审核通过
        </el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="warning"
          plain
          icon="el-icon-download"
          size="mini"
          :loading="exportLoading"
          @click="handleExport"
          v-hasPermi="['gas:courtyardNetworkManagement:export']"
        >导出
        </el-button>
      </el-col>
<!--      <el-col :span="1.5">-->
<!--        <el-button-->
<!--          type="success"-->
<!--          plain-->
<!--          icon="el-icon-download"-->
<!--          size="mini"-->
<!--          :loading="exportLoading"-->
<!--          @click="handleInstall"-->
<!--          v-hasPermi="['gas:courtyardNetworkManagement:export']"-->
<!--        >下载-->
<!--        </el-button>-->
<!--      </el-col>-->
      <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <el-table v-loading="loading" :data="courtyardNetworkManagementList" @selection-change="handleSelectionChange">
      <el-table-column type="selection" width="55" align="center"/>
      <el-table-column label="主键id" align="center" prop="id" v-if="false"/>
      <el-table-column label="序号" width="70">
        <template slot-scope="scope">
          {{(queryParams.pageNum-1)*queryParams.pageSize+scope.$index+1}}
        </template>
      </el-table-column>
      <el-table-column label="所属小区" align="center" prop="areaName"/>
      <el-table-column label="所属楼宇" align="center" prop="buildingName"/>
      <!--      <el-table-column label="所属单元" align="center" prop="unitName"/>-->
      <el-table-column label="发现问题" align="center" prop="findProblem">
        <template slot-scope="scope">
          <dict-tag :options="dict.type.courtyard_leakage" :value="scope.row.findProblem"/>
        </template>
      </el-table-column>
      <el-table-column label="审核状态" align="center" prop="processStatus">
        <template slot-scope="scope">
          <dict-tag :options="dict.type.process_status" :value="scope.row.processStatus"
                    v-if="scope.row.processStatus != null"/>
          <span v-else>未审核</span>
        </template>
      </el-table-column>
      <el-table-column label="上传人" align="center" prop="createName"/>
      <el-table-column label="创建时间" align="center" prop="createTime"/>
      <el-table-column label="照片" align="center">
        <template slot-scope="scope">
          <el-image
            style="width: 50px; height: 50px"
            :src="scope.row.photoList[0]"
            :preview-src-list="scope.row.photoList">
          </el-image>
        </template>
      </el-table-column>
      <el-table-column label="备注" align="center" prop="remarks"/>
      <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
        <template slot-scope="scope">
          <el-button
            size="mini"
            type="text"
            icon="el-icon-view"
            @click="handleUpdate(scope.row)"
            v-hasPermi="['gas:courtyardNetworkManagement:edit']"
          >查看
          </el-button>
          <el-button
            size="mini"
            type="text"
            icon="el-icon-edit"
            @click="openshShow(scope.row)"
            v-if="btnShow(scope.row)"
            v-hasPermi="['gas:courtyardNetworkManagement:edit']"
          >审核
          </el-button>
          <el-button
            size="mini"
            type="text"
            icon="el-icon-edit"
            @click="reviewListOpen(scope.row)"
          >审核记录
          </el-button>
          <el-button
            size="mini"
            type="text"
            icon="el-icon-delete"
            @click="handleDelete(scope.row)"
            v-hasPermi="['gas:courtyardNetworkManagement:remove']"
          >删除
          </el-button>
        </template>
      </el-table-column>
    </el-table>

    <pagination
      v-show="total>0"
      :total="total"
      :page.sync="queryParams.pageNum"
      :limit.sync="queryParams.pageSize"
      @pagination="getList"
    />

    <el-dialog title="审核记录" :visible.sync="reviewListShow" width="800px" append-to-body>
      <el-table
        :data="reviewList"
        style="width: 100%"
        border
        :header-cell-style="{'text-align':'center'}"
        height="500">
        <el-table-column label="历史审核记录">
          <el-table-column
            prop="createName"
            label="审核人"
            width="80">
          </el-table-column>
          <el-table-column
            prop="userPost"
            label="岗位"
            width="65">
            <template slot-scope="scope">
              <span v-if="scope.row.userPost == 'admin'">管理员</span>
              <span v-if="scope.row.userPost == 'deputyDirector'">副处长</span>
              <span v-if="scope.row.userPost == 'director'">处长</span>
              <span v-if="scope.row.userPost.indexOf('xx')>-1">队长</span>
            </template>
          </el-table-column>
          <el-table-column
            prop="processStatus"
            label="审核状态"
            width="75">
            <template slot-scope="scope">
              {{ scope.row.processStatus == '0' ? '通过' : '拒绝' }}
            </template>
          </el-table-column>
          <el-table-column
            prop="createTime"
            label="审核时间"
            width="155">
          </el-table-column>
          <el-table-column
            prop="processComments"
            label="审核意见"
            width="384">
          </el-table-column>
        </el-table-column>
      </el-table>
      <div slot="footer" class="dialog-footer">
        <el-button @click="reviewListShow = false">关 闭</el-button>
      </div>
    </el-dialog>

    <el-dialog title="审核" :visible.sync="openSH" width="500px" append-to-body>
      <el-form ref="formSH" :model="formSH" :rules="rulesSH" label-width="100px">
        <el-form-item label="审核状态" prop="processStatus">
          <el-select v-model="formSH.processStatus" placeholder="请选择审核状态" :style="{width: '100%'}">
            <el-option
              v-for="dict in dictList"
              :key="dict.value"
              :label="dict.label"
              :value="dict.value"
            ></el-option>
          </el-select>
        </el-form-item>
        <el-form-item label="审核意见" prop="processComments">
          <el-input v-model="formSH.processComments" type="textarea" placeholder="请输入审核意见" maxlength="255"/>
        </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button :loading="buttonLoading" type="primary" @click="submitFormSH">确 定</el-button>
        <el-button @click="openSH = false">关 闭</el-button>
      </div>
    </el-dialog>
    <!-- 添加或修改庭院网管对话框 -->
    <el-dialog :title="title" :visible.sync="open" width="500px" append-to-body>
      <el-form ref="form" :model="form" :rules="rules" label-width="80px" :disabled="disabled">
        <el-form-item label="所属小区" prop="areaId">
          <el-select v-model="form.areaId" filterable placeholder="请选择所属小区" clearable size="small"
                     @change="getBuildingList" style="width: 100%">
            <el-option v-for="item in areaList"
                       :key="item.id"
                       :label="item.name"
                       :value="item.id"/>
          </el-select>
        </el-form-item>
        <el-form-item label="所属楼宇" prop="buildingId">
          <el-select v-model="form.buildingId" filterable placeholder="请选择所属楼宇" @change="getUnitList"
                     clearable size="small" style="width: 100%">
            <el-option v-for="item in buildingList"
                       :key="item.id"
                       :label="item.name"
                       :value="item.id"/>
          </el-select>
        </el-form-item>
        <el-form-item label="发现问题" prop="findProblem">
          <el-radio-group v-model="form.findProblem">
            <el-radio
              v-for="dict in dict.type.courtyard_leakage"
              :key="dict.value"
              :label="dict.value"
            >{{ dict.label }}
            </el-radio>
          </el-radio-group>
        </el-form-item>
        <el-form-item label="照片" prop="photoList">
          <imageUpload v-model="form.photoList" :disabled="disabled"/>
        </el-form-item>
        <el-form-item label="备注" prop="remarks">
          <el-input v-model="form.remarks" type="textarea" placeholder="请输入备注" maxlength="255"/>
        </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button :loading="buttonLoading" type="primary" v-if="!disabled" @click="submitForm">确 定</el-button>
        <el-button @click="cancel">{{ disabled ? "关 闭" : "取 消" }}</el-button>
      </div>
    </el-dialog>
  </div>
</template>

<script>
import {
  listCourtyardNetworkManagement,
  getCourtyardNetworkManagement,
  delCourtyardNetworkManagement,
  addCourtyardNetworkManagement,
  updateCourtyardNetworkManagement, batchReview, getReviewList
} from "@/api/gas/courtyardNetworkManagement";
import {getAreaList} from "@/api/gas/area";
import {getBuildingList} from "@/api/gas/building";
import {getUnitList} from "@/api/gas/unit";
import {updateEmergencyRepair} from "@/api/gas/emergencyRepair";
import {getWorker} from "@/api/gas/user";
import {listPostAll} from "@/api/system/post";
import Cookies from "js-cookie";

export default {
  name: "CourtyardNetworkManagement",
  dicts: ['process_status', 'courtyard_leakage'],
  data() {
    return {
      buildingList: [], // 楼宇集合
      areaList: [], // 小区集合
      unitList: [], // 单元集合
      // 按钮loading
      buttonLoading: false,
      openSH: false,
      // 遮罩层
      loading: true,
      dictList:[{label:'通过',value:'0'},{label:'不通过',value:'1'}],
      // 导出遮罩层
      exportLoading: false,
      disabled: false,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 庭院网管表格数据
      courtyardNetworkManagementList: [],
      //审核记录
      reviewListShow: false,
      reviewList: [],
      workerList: [],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      // 查询参数
      queryParams: {
        areaName:undefined,
        pageNum: 1,
        pageSize: 10,
        unitId: undefined,
        processStatus: '',
        findProblem: undefined,
        createTimes: [],
        postNameArias:this.$store.state.user.postName,
        ranks: (Cookies.get("postName").indexOf('xx') > -1 ? parseInt(Cookies.get("postId")) : undefined),
      },
      pickerOptions: {
        shortcuts: [{
          text: '最近一周',
          onClick(picker) {
            const end = new Date();
            const start = new Date();
            start.setTime(start.getTime() - 3600 * 1000 * 24 * 7);
            picker.$emit('pick', [start, end]);
          }
        }, {
          text: '最近一个月',
          onClick(picker) {
            const end = new Date();
            const start = new Date();
            start.setTime(start.getTime() - 3600 * 1000 * 24 * 30);
            picker.$emit('pick', [start, end]);
          }
        }, {
          text: '最近三个月',
          onClick(picker) {
            const end = new Date();
            const start = new Date();
            start.setTime(start.getTime() - 3600 * 1000 * 24 * 90);
            picker.$emit('pick', [start, end]);
          }
        }]
      },
      // 岗位选项
      postOptions: [],
      postName: Cookies.get("postName"),
      // 表单参数
      form: {},
      formSH: {},
      rulesSH: {
        processStatus: [
          {required: true, message: "审核状态不能为空", trigger: "blur"}
        ],
      },
      // 表单校验
      rules: {
        areaId: [
          {required: true, message: "所属小区不能为空", trigger: "blur"}
        ],
        buildingId: [
          {required: true, message: "所属楼宇不能为空", trigger: "blur"}
        ],
        unitId: [
          {required: true, message: "单元id不能为空", trigger: "blur"}
        ],
        findProblem: [
          {required: true, message: "发现问题不能为空", trigger: "change"}
        ],
      }
    };
  },
  created() {
    this.getPostList();
    this.getAreaList();
    // this.getWorkerList();
    this.getList();
  },
  mounted() {
    setTimeout(
      this.getUsers(parseInt(Cookies.get("postId")))
      ,1000)
  },
  methods: {
    btnShow(row){
      let b = false;
      if (row.flag==true){
        b = true;
      }
      return b;
    },
    getUsers(value){
      if (!value) return;
      getWorker({ranks:value}).then(response => {
        this.workerListSelect = response.data;
      });
    },
    getPostList() {
      listPostAll({remark: 'ranks'}).then(response => {
        this.postOptions = response.data;
      });
    },
    getWorkerList(ranks) {
      let data = null
      if(ranks){
        data = {
          ranks:ranks
        }
      }
      getWorker(data).then(req => {
        this.workerList = req.data
      })
    },
    reviewListOpen(row){
      this.reviewList = [];
      this.reviewListShow=true;
      getReviewList({emrId: row.id}).then(res=>this.reviewList = res.rows);
    },
    submitFormSH() {
      this.$refs["formSH"].validate(valid => {
        if (valid) {
          this.buttonLoading = true;
          const postNameArias = this.$store.state.user.postName;
          this.formSH.postNameArias = postNameArias
          if (this.formSH.id != null) {
            updateCourtyardNetworkManagement(this.formSH).then(response => {
              this.$modal.msgSuccess("审核成功");
              this.openSH = false;
              this.getList();
            }).finally(() => {
              this.buttonLoading = false;
            });
          }else if (this.formSH.uids.length > 0) {
            batchReview(this.formSH).then(response => {
              this.$modal.msgSuccess("审核成功");
              this.openSH = false;
              this.getList();
            }).finally(() => {
              this.buttonLoading = false;
            });
          }
        }
      })
    },
    chushiBatch(){
      if (this.ids.length > 0) {
        let chushiForm = {uids:[],processStatus:null,processComments:null,postNameArias:null}
        chushiForm.processStatus = '0';
        chushiForm.processComments = '一键审核通过';
        chushiForm.uids = this.ids;
        chushiForm.postNameArias = this.$store.state.user.postName;
        console.log(chushiForm)
        batchReview(chushiForm).then(response => {
          if (response.code===200) {
            this.$modal.msgSuccess("审核成功");
          }
          this.getList();
        })
      }
    },
    openshShow(data, isBatch) {
      this.formSH = {
        id: undefined,
        postNameArias: undefined,
        uids: [],
        processStatus: undefined,
        processComments: undefined,
      }
      if (isBatch)
        this.formSH.uids = this.ids
      else
        this.formSH.uids = [data.id]
      this.openSH = true
    },
    // 小区下拉
    getAreaList() {
      getAreaList().then(req => this.areaList = req.data)
    },
    // 楼宇下拉
    getBuildingList() {
      this.form.buildingId = undefined
      this.queryParams.buildingId = undefined
      let areaId = this.form.areaId || this.queryParams.areaId
      getBuildingList(areaId).then(req => this.buildingList = req.data)
    },
    getUnitList() {
      this.form.unitId = undefined
      this.queryParams.unitId = undefined
      let buildingId = this.form.buildingId || this.queryParams.buildingId
      getUnitList(buildingId).then(req => this.unitList = req.data)
    },
    /** 查询庭院网管列表 */
    getList() {
      this.loading = true;
      listCourtyardNetworkManagement(this.queryParams).then(response => {
        this.courtyardNetworkManagementList = response.rows;
        this.total = response.total;
        this.loading = false;
      });
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        id: undefined,
        unitId: undefined,
        findProblem: undefined,
        remarks: undefined,
        delFlag: undefined,
        createBy: undefined,
        createTime: undefined,
        updateBy: undefined,
        updateTime: undefined
      };
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.workerListSelect=[]
      this.queryParams.createTimes=[]
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map(item => item.id)
      this.single = selection.length !== 1
      this.multiple = !selection.length
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.open = true;
      this.disabled = false;
      this.title = "添加庭院网管";
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.loading = true;
      this.disabled = true;
      this.reset();
      const id = row.id || this.ids
      getCourtyardNetworkManagement(id).then(response => {
        this.loading = false;
        this.form = response.data;
        let buildingId = this.form.buildingId
        let unitId = this.form.unitId
        this.getBuildingList(this.form.areaId)
        this.form.buildingId = buildingId
        this.getUnitList(this.form.buildingId)
        this.form.unitId = unitId
        this.open = true;
        this.title = "查看庭院网管";
      });
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs["form"].validate(valid => {
        if (valid) {
          this.buttonLoading = true;
          if (this.form.id != null) {
            if (typeof this.form.photoList === 'string') {
              this.form.photoList = this.form.photoList.split(',')
            }
            updateCourtyardNetworkManagement(this.form).then(response => {
              this.$modal.msgSuccess("修改成功");
              this.open = false;
              this.getList();
            }).finally(() => {
              this.buttonLoading = false;
            });
          } else {
            this.form.photoList = this.form.photoList.split(',')
            addCourtyardNetworkManagement(this.form).then(response => {
              this.$modal.msgSuccess("新增成功");
              this.open = false;
              this.getList();
            }).finally(() => {
              this.buttonLoading = false;
            });
          }
        }
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const ids = row.id || this.ids;
      this.$modal.confirm('是否确认删除庭院网管编号为"' + ids + '"的数据项？').then(() => {
        this.loading = true;
        return delCourtyardNetworkManagement(ids);
      }).then(() => {
        this.loading = false;
        this.getList();
        this.$modal.msgSuccess("删除成功");
      }).finally(() => {
        this.loading = false;
      });
    },
    /** 导出按钮操作 */
    handleExport() {
      this.$download.excel('/gas/courtyardNetworkManagement/export', this.queryParams);
    },
    handleInstall() {
      this.$download.excel('/gas/courtyardNetworkManagement/install', this.queryParams);
    }
  }
};
</script>
